unit unitcontrol;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TFrmConfig }

  TFrmConfig = class(TForm)
    ButConfOk: TButton;
    ButConfCancel: TButton;
    EdtAlfa: TEdit;
    EdtEpsErroELS: TEdit;
    EdtEpsilonELSF: TEdit;
    EdtEpsErroELU: TEdit;
    EdtEpsErroMomCurv: TEdit;
    GroupBoxELS1: TGroupBox;
    GroupBoxELU: TGroupBox;
    GroupBoxMomCurv: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    RadioGrpRupturaTracao: TRadioGroup;
    procedure ButConfCancelClick(Sender: TObject);
    procedure ButConfOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FrmConfig: TFrmConfig;
  fControlEps:real;

implementation
uses unitprincipal;

{ TFrmConfig }


procedure TFrmConfig.ButConfCancelClick(Sender: TObject);
begin
  FrmConfig.Close;
end;

procedure TFrmConfig.ButConfOkClick(Sender: TObject);
begin
  fELUalfa:=StrToFloat(EdtAlfa.Text);
  fEpsilonErroELU:=StrToFloat(EdtEpsErroELU.Text); // Primeiro Groupbox

  fEpsilonErroMomCurv:=StrToFloat(EdtEpsErroMomCurv.Text); // Segundo Groupbox

  fEpsilonErroELS:=StrToFloat(EdtEpsErroELS.Text); // Terceiro Groupbox
  fEpsilonELSF:=StrToFloat(EdtEpsilonELSF.Text);

  if RadioGrpRupturaTracao.ItemIndex=0 then fModoDeRupturaDefault:=0;
  if RadioGrpRupturaTracao.ItemIndex=1 then fModoDeRupturaDefault:=1;
  fModoDeRuptura:=0;                                      //Ruptura no concreto
  if fbArmPas then begin
    if fModoDeRupturaDefault=1 then fModoDeRuptura:=1;    //Ruptura na armadura, se houver armadura e se o usuario desejar
  end;

  FrmConfig.Close;
end;

procedure TFrmConfig.FormCreate(Sender: TObject);
begin
  EdtAlfa.Text:=FloatToStr(fELUalfa);
  EdtEpsErroELU.Text:=FloatToStr(fEpsilonErroELU);
  EdtEpsErroMomCurv.Text:=FloatToStr(fEpsilonErroMomCurv);
  EdtEpsErroELS.Text:=FloatToStr(fEpsilonErroELS);
  EdtEpsilonELSF.Text:=FloatToStr(fEpsilonELSF);
  if fModoDeRupturaDefault=0 then RadioGrpRupturaTracao.ItemIndex:=0;
  if fModoDeRupturaDefault=1 then RadioGrpRupturaTracao.ItemIndex:=1;
  if fbArmPas=True then RadioGrpRupturaTracao.Enabled:=True;
  if fbArmPas=False then RadioGrpRupturaTracao.Enabled:=False;
end;

procedure TFrmConfig.FormShow(Sender: TObject);
begin
  EdtAlfa.Text:=FloatToStr(fELUalfa);
  EdtEpsErroELU.Text:=FloatToStr(fEpsilonErroELU);
  EdtEpsErroMomCurv.Text:=FloatToStr(fEpsilonErroMomCurv);
  EdtEpsErroELS.Text:=FloatToStr(fEpsilonErroELS);
  EdtEpsilonELSF.Text:=FloatToStr(fEpsilonELSF);
  if fModoDeRupturaDefault=0 then RadioGrpRupturaTracao.ItemIndex:=0;
  if fModoDeRupturaDefault=1 then RadioGrpRupturaTracao.ItemIndex:=1;
  if fbArmPas=True then RadioGrpRupturaTracao.Enabled:=True;
  if fbArmPas=False then RadioGrpRupturaTracao.Enabled:=False;
end;


{$R *.lfm}

end.

