unit UnitMat;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TMateriais }

  TMateriais = class(TForm)
    ButMatOk: TButton;
    ButMatCanc1: TButton;
    EdtEtaP1: TEdit;
    EdtEpsilonsu: TEdit;
    EdtEs: TEdit;
    EdtEp: TEdit;
    EdtFck: TEdit;
    EdtFptd: TEdit;
    EdtFyk: TEdit;
    EdtFpyd: TEdit;
    EdtGamaC: TEdit;
    EdtGamaS: TEdit;
    EdtEpsilonpu: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure ButMatCanc1Click(Sender: TObject);
    procedure ButMatOkClick(Sender: TObject);
    procedure EdtFckChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Materiais: TMateriais;

implementation

uses unitprincipal;

{ TMateriais }

procedure TMateriais.ButMatOkClick(Sender: TObject);
begin
ffck:=Strtofloat(EdtFck.Text);
fGamaC:=Strtofloat(EdtGamaC.Text);
ffcd:=ffck/fGamaC/10;
ffyk:=Strtofloat(EdtFyk.Text);
fGamaS:=Strtofloat(EdtGamaS.Text);
fEs:=Strtofloat(EdtEs.Text)*100;
fEpsilonsu:=-StrToFloat(EdtEpsilonsu.Text);
ffyd:=ffyk/fGamaS/10;
fEpsilonYD:=ffyd/fEs*1000;

ffpyd:=-StrToFloat(EdtFpyd.Text)/10;
ffptd:=-StrToFloat(EdtFptd.Text)/10;
fEp:=StrToFloat(EdtEp.Text)*100;
fEpsilonpu:=-StrToFloat(EdtEpsilonpu.Text);
fEtaP1:=StrToFloat(EdtEtaP1.Text);

  if ffck<=50 then
     begin
       fEpsilonC2:=2;
       fEpsilonCU:=3.5;
       fNTensaoConcreto:=2;
     end
  else
     begin
       if (ffck)<90 then
          begin
             fEpsilonC2:=2+0.085*exp(ln(ffck-50)*0.53);
             fEpsilonCU:=2.6+35*exp(ln((90-ffck)/100)*4);
             fNTensaoConcreto:=1.4+23.4*exp(ln((90-ffck)/100)*4);
           end;
       if (ffck)>=90 then
          begin
             fEpsilonC2:=2.6;
             fEpsilonCU:=2.6;
             fNTensaoConcreto:=1.4;
          end;
     end;

     unitprincipal.FrmMainFrm.StatusBar1.Panels[0].Text:='fck = '+floattostr(ffck)+' MPa';
     unitprincipal.FrmMainFrm.StatusBar1.Panels[1].Text:='fcd = '+floattostrf(ffcd,ffGeneral,5,3)+' kN/cm²';
     unitprincipal.FrmMainFrm.StatusBar1.Panels[2].Text:='n = '+floattostrf(fNTensaoConcreto,ffGeneral,5,3);
     unitprincipal.FrmMainFrm.StatusBar1.Panels[3].Text:='Deformações c2 e cu = '+floattostrf(fEpsilonC2,ffGeneral,5,3)+' e '+floattostrf(fEpsilonCU,ffGeneral,5,3);
     unitprincipal.FrmMainFrm.StatusBar1.Panels[4].Text:='fyk = '+floattostr(ffyk)+' MPa';
     unitprincipal.FrmMainFrm.StatusBar1.Panels[5].Text:='fyd = '+floattostrf(ffyd,ffGeneral,5,3)+' kN/cm²';
     unitprincipal.FrmMainFrm.StatusBar1.Panels[6].Text:='Es = '+floattostrf(fEs,ffGeneral,5,3)+' kN/cm²';
     unitprincipal.FrmMainFrm.StatusBar1.Panels[7].Text:='Deformação Limite do Aço = '+floattostrf(fEpsilonYD,ffGeneral,5,3);

Materiais.Close;
end;

procedure TMateriais.EdtFckChange(Sender: TObject);
begin
  if EdtFck.Text<>'' then
     begin
       if StrToFloat(EdtFck.Text)>90 then EdtFck.Text:='90';
     end;
end;

procedure TMateriais.ButMatCanc1Click(Sender: TObject);
begin
  Materiais.Close;
end;

procedure TMateriais.FormCreate(Sender: TObject);
begin
  EdtFck.Text:=floattostr(ffck);
  EdtGamaC.Text:=floattostr(fGamaC);
  EdtFyk.Text:=floattostr(ffyk);
  EdtGamaS.Text:=floattostr(fGamaS);
  EdtEs.Text:=floattostr(fEs/100);
  EdtEpsilonsu.Text:=floattostr(-fEpsilonsu);
  EdtFpyd.Text:=floattostr(-ffpyd*10);
  EdtFptd.Text:=floattostr(-ffptd*10);
  EdtEp.Text:=floattostr(fEp/100);
  EdtEpsilonpu.Text:=floattostr(-fEpsilonpu);
  EdtEtaP1.Text:=floattostr(fEtaP1);
end;

procedure TMateriais.FormShow(Sender: TObject);
begin
  EdtFck.Text:=floattostr(ffck);
  EdtGamaC.Text:=floattostr(fGamaC);
  EdtFyk.Text:=floattostr(ffyk);
  EdtGamaS.Text:=floattostr(fGamaS);
  EdtEs.Text:=floattostr(fEs/100);
  EdtEpsilonsu.Text:=floattostr(-fEpsilonsu);
  EdtFpyd.Text:=floattostr(-ffpyd*10);
  EdtFptd.Text:=floattostr(-ffptd*10);
  EdtEp.Text:=floattostr(fEp/100);
  EdtEpsilonpu.Text:=floattostr(-fEpsilonpu);
  EdtEtaP1.Text:=floattostr(fEtaP1);
end;


{$R *.lfm}
end.

